Index: main/asterisk.c
===================================================================
--- main/asterisk.c	(revision 81419)
+++ main/asterisk.c	(working copy)
@@ -2530,7 +2530,7 @@
 	FILE *f;
 	sigset_t sigs;
 	int num;
-	int is_child_of_nonroot = 0;
+	int can_drop_privs = 1;
 	char *buf;
 	char *runuser = NULL, *rungroup = NULL;
 
@@ -2560,7 +2560,7 @@
 	 * it can't issue setuid(), setgid(), setgroups() or set_priority() 
 	 */
 	if (getenv("ASTERISK_ALREADY_NONROOT"))
-		is_child_of_nonroot=1;
+		can_drop_privs=0;
 	if (getenv("HOME")) 
 		snprintf(filename, sizeof(filename), "%s/.asterisk_history", getenv("HOME"));
 	/* Check for options */
@@ -2668,6 +2668,7 @@
 	 * We do this for the benefit of init scripts (which need to know if/when
 	 * the main asterisk process has died yet). */
 	if (ast_opt_remote) {
+		can_drop_privs = 0;
 		strcpy(argv[0], "rasterisk");
 		for (x = 1; x < argc; x++) {
 			argv[x] = argv[0] + 10;
@@ -2695,10 +2696,10 @@
 
 #ifndef __CYGWIN__
 
-	if (!is_child_of_nonroot) 
+	if (can_drop_privs) 
 		ast_set_priority(ast_opt_high_priority);
 
-	if (!is_child_of_nonroot && rungroup) {
+	if (can_drop_privs && rungroup) {
 		struct group *gr;
 		gr = getgrnam(rungroup);
 		if (!gr) {
@@ -2717,7 +2718,7 @@
 			ast_verbose("Running as group '%s'\n", rungroup);
 	}
 
-	if (!is_child_of_nonroot && runuser) {
+	if (can_drop_privs && runuser) {
 		struct passwd *pw;
 		pw = getpwnam(runuser);
 		if (!pw) {
